# Borer1413.tcl---Time stamping module control frame


set frame "Borer1413"
set frametitle "Borer 1413 clock/calendar module"
set icontitle "Borer1413"

set mname "borer1413"

set maxmodule 4
set maxadc 9

set module 1

set wrname(ENABLE)	enable
set rrname(ENABLE)	enable

set rrname(DATA)     data


for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd "enable"
 
proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module with arguments"}
   camac-address
}

proc repaint {} {
   global module
   :modify MODULE-NUM :value $module
}
 
proc click-enable {} {read-reg enable}

proc click-update {} {
   global channel
   set register data
   set channel 9
   :modify YEAR :value [expr [read-channel-reg $register] & 255]
   set channel 8
   :modify MTH :value [expr [read-channel-reg $register] & 255]
   set channel 7
   :modify DAY :value [expr [read-channel-reg $register] & 255]
   set channel 6
   :modify HRS :value [expr [read-channel-reg $register] & 255]
   set channel 5
   :modify MINS :value [expr [read-channel-reg $register] & 255]
   set channel 4
   :modify SECS :value [expr [read-channel-reg $register] & 255]
   set channel 3
   :modify TENTHS :value [expr [read-channel-reg $register] & 255]
   click-enable
}

proc current-time {} {
   global channel
   set register data
   set channel 9
   set data9 [expr [read-channel-reg $register] & 255]
   set channel 8
   set data8 [expr [read-channel-reg $register] & 255]
   set channel 7
   set data7 [expr [read-channel-reg $register] & 255]
   set channel 6
   set data6 [expr [read-channel-reg $register] & 255]
   set channel 5
   set data5 [expr [read-channel-reg $register] & 255]
   set channel 4
   set data4 [expr [read-channel-reg $register] & 255]
   set channel 3
   set data3 [expr [read-channel-reg $register] & 255]
   click-enable
   return "$data9 $data8 $data7 $data6 $data5 $data4 $data3"
}

proc click arg {
   global debug
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      MODULE-SEL      -
      MODULE-NUM      {click-select-module $v}

      default   {puts stdout $arg}
   }
}

set selectmodulemenu {1 2 3 4}


proc make-frame {} {
  global env maxmodule camcrate camstation
  global selectmodulemenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10
      :vskip 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu 
      :next-row T
      :text CAM-CRATE   :label "CAMAC Crate:"     :w 5 :value $camcrate :deaf T
      :text CAM-STATION :label "CAMAC Station:"   :w 5 :value $camstation :deaf T
   
   :panel DATA :layout T :padx 10 :pady 10
      :layout V
      :message M1 :label "Current Time" :bold T :valuex 20c
      :text YEAR  :label Year   :w 5  :value 0  :deaf T :valuex 20c
      :text MTH   :label Month  :w 5  :value 0  :deaf T :valuex 20c
      :text DAY   :label Day    :w 5  :value 0  :deaf T :valuex 20c
      :text HRS   :label Hours    :w 5  :value 0  :deaf T :valuex 20c
      :text MINS  :label Minutes  :w 5  :value 0  :deaf T :valuex 20c
      :text SECS  :label Seconds  :w 5  :value 0  :deaf T :valuex 20c
      :text TENTHS :label "0.1s"  :w 5  :value 0  :deaf T :valuex 20c

   :panel CLICK :layout T :padx 10
      :layout H; :col-gap 20
      :button UPDATE :label "Update"        :command click-update
      :button ENABLE :label "Enable Module" :command click-enable
      
   :show T

}
