# FR48REG.defn.tcl


proc {FR48REG} {name c n} {
          define-register $name cCAMAC clear          "-c$c -n$n -a0 -f9"
          define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"

          define-register $name xCAMAC status         "-c$c -n$n -a4 -f0 -prw -l0 -b0 -i0"
          define-register $name xCAMAC status.vsn     "-c$c -n$n -a4 -f0 -prw -l8 -b0"
          define-register $name xCAMAC status.term    "-c$c -n$n -a4 -f0 -pro -l1 -b12 -zd"
          define-register $name xCAMAC status.strobe  "-c$c -n$n -a4 -f0 -pro -l1 -b13 -zd"
          define-register $name xCAMAC status.fera    "-c$c -n$n -a4 -f0 -prw -l1 -b14 -zd"
          define-register $name xCAMAC status.mode    "-c$c -n$n -a4 -f0 -prw -l1 -b15 -zd"

          define-register $name xCAMAC datal          "-c$c -n$n -a0 -f0 -w16 -pro -l0 -b0 -zx"
          define-register $name xCAMAC datam          "-c$c -n$n -a1 -f0 -w16 -pro -l0 -b0 -zx"
          define-register $name xCAMAC datah          "-c$c -n$n -a2 -f0 -w16 -pro -l0 -b0 -zx"
}

proc {FR48REG_DAQ-reset} {module vsn} {
#   FR48REG
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-register $module.status
   write-register $module.status.vsn $vsn
}

proc {FR48REG_DAQ-go} {module vsn} {
#   FR48REG
    read-register $module.clear
    write-register $module.status.vsn $vsn
    write-register $module.status.fera 1
}

proc {FR48REG_DAQ-halt} {args} {
#   FR48REG
    set module [first $args]
   write-register $module.status.fera 0
}

