# FR48REG.tcl--- Fera 48bit register module control frame


set frame FR48REG
set frametitle "FERA 48bit Register Setup & Monitor"
set icontitle "FR48REG"

set mname "fr48reg"

set maxmodule 8

set maxmodule [inform camaccontrol inquire [set mname]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}

set module [first $modulelist]

set wrname(CLEAR)       clear

set wrname(SVSN)	status.vsn
set wrname(SFERA)	status.fera
set wrname(SMODE)	status.mode

set rrname(CLEAR)       clear

set rrname(DATAL)	datal
set rrname(DATAM)	datam
set rrname(DATAH)	datah

set rrname(SVSN)	status.vsn
set rrname(STERM)	status.term
set rrname(SSTR)	status.strobe
set rrname(SFERA)	status.fera
set rrname(SMODE)	status.mode



for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac


proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module with arguments"}
   camac-address
   set register datal
#   update-text-widget $register [read-reg $register]
   set register datam
#   update-text-widget $register [read-reg $register]
   set register datah
#   update-text-widget $register [read-reg $register]

   set register status.vsn
   update-text-widget $register [read-reg $register]
   set register status.term
   update-widget $register [read-reg $register]
   set register status.strobe
   update-widget $register [read-reg $register]
   set register status.fera
   update-widget $register [read-reg $register]
   set register status.mode
   update-widget $register [read-reg $register]
}

proc click-select-adc {i} {}

proc click arg {
   global debug rrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      MODULE-SEL      -
      MODULE-NUM      {click-select-module $v}

      ALL-MODULES {click-all-modules $v}
 
      SMODE	-
      SFERA    {click-box $w $v}

      CLEAR	    {write-reg $rrname($w) 0}

      REDISPLAY	{click-redisplay}
      default   {puts stdout $arg}
   }
}


proc make-frame {} {
  global env camcrate camstation maxmodule modulelist


  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10 :pady 10
     :layout H; :row-gap 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $modulelist
      :hskip 20
      :text CAM-CRATE   :label "CAMAC Crate:"   :w 5 :value "00" :deaf T
      :text CAM-STATION :label "CAMAC Station:" :w 5 :value "00" :deaf T

      :next-row T
      :message MSGSR :label "Status Register:" :bold T 
      :row-gap 5
      :next-row T
      :hskip 40
      :text SVSN :label "VSN:" :w 5 :value "00"
      :hskip 200
      :checkbox ALL-MODULES :label "Act on ALL modules?"

      :next-row T; :col-gap 40
      :hskip 30
      :checkbox SMODE  :label "Mode:"
      :checkbox SFERA  :label "Fera Enable:"
      :checkbox SSTR   :label "Strobe received:"  :deaf T
      :checkbox STERM  :label "Termination in:"  :deaf T

   :panel DATA :layout T :padx 10
      :layout H; :row-gap 20
      :text DATAL :label "Data 0-15:"  :w 10 :value 0 :deaf T
      :text DATAM :label "Data 16-31:" :w 10 :value 0 :deaf T
      :text DATAH :label "Data 32-47:" :w 10 :value 0 :deaf T
   
   :panel CLICK :layout B :padx 10 :pady 10 :after FOOTER
      :layout H; :col-gap 20
      :button REDISPLAY :label "Redisplay"
      :button CLEAR     :label "Clear Module"

      :show T

}
