#  FRC.defn.tcl

proc {Fera RC} {name c n} {
      define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"
      define-register $name cCAMAC resetEC        "-c$c -n$n -a1 -f9"
      define-register $name cCAMAC resetFIFOs     "-c$c -n$n -a2 -f9"
      define-register $name cCAMAC ClearFera      "-c$c -n$n -a3 -f9"

      define-register $name xCAMAC Counter.LSB   "-c$c -n$n -a2 -f1 -pro -l0 -b0 -zx"
      define-register $name xCAMAC Counter.MSB   "-c$c -n$n -a3 -f1 -pro -l0 -b0 -zx"
      define-register $name xCAMAC MPX0          "-c$c -n$n -a0 -f1 -prw -l8 -b0 -zd"  
      define-register $name xCAMAC MPX1          "-c$c -n$n -a1 -f1 -prw -l8 -b0 -zd" 

      define-register $name xCAMAC VSN           "-c$c -n$n -a0 -f0 -prw -l8 -b0 -zd -i0"  
      define-register $name xCAMAC Gate.Delay    "-c$c -n$n -a3 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC Gate.Width    "-c$c -n$n -a4 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC Clear.Delay   "-c$c -n$n -a5 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC Clear.Width   "-c$c -n$n -a6 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC Busy.Delay    "-c$c -n$n -a7 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC Busy.Width    "-c$c -n$n -a8 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC FTSample      "-c$c -n$n -a9 -f0 -prw -l8 -b0 -zd" 
      define-register $name xCAMAC ValSample     "-c$c -n$n -a10 -f0 -prw -l8 -b0 -zd" 

      define-register $name xCAMAC CF0           "-c$c -n$n -a1 -f0 -prw -l8 -b0 -i0 -zx"
      define-register $name xCAMAC DreqEnable    "-c$c -n$n -a1 -f0 -prw -l1 -b0 -zd"
      define-register $name xCAMAC ValEnable     "-c$c -n$n -a1 -f0 -prw -l1 -b1 -zd"
      define-register $name xCAMAC EndClearEnable "-c$c -n$n -a1 -f0 -prw -l1 -b2 -zd"
      define-register $name xCAMAC WdEnable      "-c$c -n$n -a1 -f0 -prw -l1 -b3 -zd"
      define-register $name xCAMAC WdDelay       "-c$c -n$n -a1 -f0 -prw -l4 -b4 -zd"  

      define-register $name xCAMAC CF1            "-c$c -n$n -a2 -f0 -prw -l8 -b0 -i0 -zx"
      define-register $name xCAMAC FTSampleEnable "-c$c -n$n -a2 -f0 -prw -l1 -b2 -zd"
      define-register $name xCAMAC ValSampleEnable "-c$c -n$n -a2 -f0 -prw -l1 -b3 -zd"  
      define-register $name xCAMAC GateEnable     "-c$c -n$n -a2 -f0 -prw -l1 -b4 -zd"  
      define-register $name xCAMAC StartStop      "-c$c -n$n -a2 -f0 -prw -l1 -b5 -zd" 
      define-register $name xCAMAC ECAdjustEnable "-c$c -n$n -a2 -f0 -prw -l1 -b6 -zd" 
      define-register $name xCAMAC FeraInhibit    "-c$c -n$n -a2 -f0 -prw -l1 -b7 -zd" 
} 



proc {Fera RC_DAQ-reset} {args} {
#   LC4532
   set module [first $args]
   set r [read-register $module.reset]
   if {[string index $r 2] == "0"} then {no-QX $module.status}
}

proc {Fera RC_DAQ-go} {args} {
#   LC4532
   set module [first $args]
   read-register $module.resetEC
   read-register $module.resetFIFOs
   read-register $module.ClearFera
}

proc {Fera RC_DAQ-halt} {args} {
#   LC4532
}


#    for camacsaverestore
set {Fera RC_registersavepatterns} {FTSample ValSample Busy.Delay Busy.Width Gate.Width Gate.Delay Clear.Delay Clear.Width}
