#  HM 413.defn.tcl

proc {Ortec HM413} {name c n} {
      define-register $name cCAMAC   clear          "-c$c -n$n -a1 -f9"
      define-register $name cCAMAC   clear.mem      "-c$c -n$n -a0 -f9"
      define-register $name xCAMAC   config         "-c$c -n$n -a2 -f17 -pwo -l8 -b0 -zd -i4"
      define-register $name xCAMAC   config.vsn1    "-c$c -n$n -a0 -f17 -pwo -l8 -b0 -zd -i16"
      define-register $name xCAMAC   config.vsn2    "-c$c -n$n -a1 -f17 -pwo -l8 -b0 -zd -i32"
      define-register $name cCAMAC   enable.lam     "-c$c -n$n -a0 -f26 -prw"
      define-register $name cCAMAC   disable.lam    "-c$c -n$n -a0 -f24 -prw"
      define-register $name cCAMAC   test.lam       "-c$c -n$n -a0 -f8  -pro"
      define-register $name cCAMAC   coinc.disable  "-c$c -n$n -a2 -f24 -prw"
      define-register $name cCAMAC   coinc.enable   "-c$c -n$n -a2 -f26 -prw"
      define-register $name cCAMAC   start.hist     "-c$c -n$n -a1 -f26"
      define-register $name cCAMAC   stop.hist      "-c$c -n$n -a1 -f24"
      define-register $name xCAMAC   vsn1.enable    "-c$c -n$n -a2 -f17 -pwo -l1 -b0 -zd"
      define-register $name xCAMAC   vsn2.enable    "-c$c -n$n -a2 -f17 -pwo -l1 -b1 -zd"
      define-register $name xCAMAC   config.bit1    "-c$c -n$n -a2 -f17 -pwo -l1 -b3 -zd -i1"
      define-register $name xCAMAC   config.bit2    "-c$c -n$n -a2 -f17 -pwo -l1 -b4 -zd -i0"
      define-register $name xCAMAC   config.bit3    "-c$c -n$n -a2 -f17 -pwo -l1 -b5 -zd -i0"
      define-register $name xCAMAC   segment.select "-c$c -n$n -a3 -f17 -pwo -l8 -b0"
      define-register $name xCAMAC   config.read    "-c$c -n$n -a0 -f1  -pro -l5 -b0"
      define-register $name xCAMAC   addr.mem       "-c$c -n$n -a0 -f16 -pwo -l0 -b0"
      define-register $name xCAMAC   read.data      "-c$c -n$n -a0 -f0 -prw"
} 

proc {Ortec HM413_DAQ-reset} {args} {
#   HM413
   set module [first $args]
   set vsn [second $args]
   if {[read-register $module.clear] == "%00"} then {no-QX $module.clear}
}

proc {Ortec HM413_DAQ-go} {args} {
#   HM413

  insert-log "HM 413 DAQ GO at [date]"

   set module [first $args]
   set vsn [second $args]

   read-register $module.start.hist 
}

proc {Ortec HM413_DAQ-halt} {args} {
#   HM413

  insert-log "HM 413 DAQ HALT at [date]"

   set module [first $args]

   read-register $module.stop.hist
}

#    for camacsaverestore
set {Ortec HM413_registersavepatterns} {config segment.select config.bit1 config.bit2 config.bit3 vsn1.enable vsn2.enable}
