# HM413.tcl---ORTEC 413 Histogramming memory control frame

# This script is under construction...- CW
# last modification 2001/01/19
set debug 0

set frame HM413
set frametitle "HM 413 Histogramming Memory Control & Monitor"
set icontitle "HM 413"

set mname "hm413"

set maxmodule 32
set selectsegmentmenu {}

#mapping the module into the VME

set HMbaseAddress 0x18000000
set HSMmemOffset 0

set maxmodule [inform camaccontrol inquire [set mname]count]
set modulelist {}
for {set i 1} {$i <= $maxmodule} {incr i} {lappend modulelist $i}


set module [first $modulelist]

set maxadc 0
set nchannels 0
#set maxsegment 32
set segmentnbr 0
set memAddr 0
set memAddrInc 0
set vsn1 "0x00"
set vsn2 "0x00"
set nbr_of_seg 0

set wrname(CLEAR)             clear
set wrname(CLEARMEM)          clear.mem

set wrname(CONFIG)	      config
set wrname(CONFIGVSN1)        config.vsn1
set wrname(CONFIGVSN2)        config.vsn2
set wrname(DISABLE)           disable.lam
set wrname(ENABLE)	      enable.lam
set wrname(COINCMODE)         coinc.disable
set wrname(COINCMODE)	      coinc.enable
set wrname(START)             start.hist
set wrname(STOP)              stop.hist
set wrname(EVSN1)	      vsn1.enable
set wrname(EVSN2)	      vsn2.enable
set wrname(ESS1)	      config.bit1
set wrname(ESS2)	      config.bit2
set wrname(ESS3)	      config.bit3
set wrname(SELECT)            segment.select
set wrname(ADDR)	      addr.mem

set rrname(CLEAR)             clear
set rrname(CLEARMEM)          clear.mem

#set rrname(CONFIG)	      config
set rrname(CONFREAD)          config.read
set rrname(CONFIGVSN1)        config.vsn1
set rrname(CONFIGVSN2)        config.vsn2
set rrname(TESTLAM)	      test.lam
set rrname(COINCMODE)         coinc.disable
set rrname(COINCMODE)         coinc.enable
set rrname(START)             start.hist
set rrname(STOP)              stop.hist
set rrname(EVSN1)	      vsn1.enable
set rrname(EVSN2)	      vsn2.enable
set rrname(ESS1)              config.bit1
set rrname(ESS2)              config.bit2
set rrname(ESS3)              config.bit3
set rrname(SELECT)            segment.select
set rrname(ADDR)	      addr.mem
set rrname(DATA)	      read.data



if {[info exists env(VmeServer)] == 0} then {set resource vme}  \
   else {set resource $env(VmeServer)}

for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd clear

proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   global memAddr memAddrInc
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   set register config
   update-widget $register [read-reg $register]
   set register config.vsn1
   update-widget $register [read-reg $register]
   set register config.vsn2
   update-widget $register [read-reg $register]
#   set register coinc.disable
#   update-widget $register [read-reg $register]
#   set register coinc.enable
#   update-widget $register [read-reg $register]
   set register start.hist
   update-widget $register [read-reg $register]
   set register stop.hist
   update-widget $register [read-reg $register]
   set register vsn1.enable
   update-widget $register [read-reg $register]
   set register vsn2.enable
   update-widget $register [read-reg $register]
   set register config.bit1
   update-widget $register [read-reg $register]
   set register config.bit2
   update-widget $register [read-reg $register]
   set register config.bit3
   update-widget $register [read-reg $register]
#   set register segment.select
#   update-widget $register [read-reg $register]
   set register addr.mem
   update-widget $register [read-reg $register]


}

proc do_readsegment {current} {
  global debug nbr_of_seg
     if {$debug} then {puts stderr "click-read-segment"}
       set currentseg current
       if {$nbr_of_seg == 2}  then {set segmentsize 16384}
       if {$nbr_of_seg == 4}  then {set segmentsize  8192}
       if {$nbr_of_seg == 8}  then {set segmentsize  4096}
       if {$nbr_of_seg == 16} then {set segmentsize  2048}
       if {$nbr_of_seg == 32} then {set segmentsize  1024}
       set-footer "reading memory segment $currentsegment"
       click-segment-num $currentseg
       :modify MEMDISPLAY :strings "\n Segment $currentsegment Memory dump (size $segmentsize words)\n"
       for {set i 1} {$i <= $segmentsize} {incr i} {
            write-reg read.data 1
	    set data [string trimleft [read-reg Camac.Data]]
            :modify MEMDISPLAY :strings "$data"
           if {[expr ($i / 8) * 8] == $i} then {:modify MEMDISPLAY :strings "\n"}
        }

}


proc do_memRead args {
   global memAddr memAddrInc

  set words 64
  set hmfullsize 32767
   
  write-reg addr.mem $memAddr
  :modify MEMDISPLAY :strings "\n    Memory Offset $memAddr\n"

  for {set i 1} {$i <= $words} {incr i} {
      
     # set data [string trimleft [read-reg read.data]]
       set data [string trimleft [read-camac-register "Data"]]
      :modify MEMDISPLAY :strings "$data"
      if {[expr ($i / 8) * 8] == $i} then {:modify MEMDISPLAY :strings "\n"}
  }

  if {$memAddrInc != 0} then {set memAddr [expr $memAddr + 64]}
 # redisplay-module
}

proc do_absolute_scan_mem {} {
   global memAddr memAddrInc

   set hmfullsize 32767
   write-reg addr.mem $memAddr
    write-camac-register "Address" $memAddr
   :modify MEMDISPLAY :strings "\n  Reading of entire Memory - Address base is $memAddr"


#   for {set i $memAddr} {$i <= $hmfullsize} {incr i} {
        read-reg read.data
   	set data [string trimleft [read-camac-register "Data"]]
	:modify MEMDISPLAY :strings "$data"
#	if {[expr ($i / 8) * 8] == $i} then {:modify MEMDISPLAY :strings "\n"}
 #  }
   
   if {$memAddrInc != 0} then {set memAddr [expr $memAddr + 64]}
   
}
   
   
   
proc click arg {
   global debug wrname
   global memAddr memAddrInc
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL-MENU -

      MODULE-SEL      -   
      MODULE-NUM  {click-select-module $v}   

      SEGMENT-NUM     -
      SEGMENT-NBR {click-segment-num $v}   
      SEGMENT-SEL {click-select-segment}
      ENABLE      {write-reg $wrname($w) $v}
      INCR        {set memAddrInc $v}
      ADDR        {set memAddr $v}
      
      CONFIGVSN1  {click-text $w $v}
      CONFIGVSN2      -
      EVSN1       {click-box $w $v}
      EVSN2           -
      ESS1            -
      ESS2            -
      ESS3        {click-box $w $v}         
      LAM         {click-lam $v}

      START       {click-stop-go {0}}
      STOP        {click-stop-go {1}}
      
      COINCMODE   {click-coinc $v}
      CLEARMEM    {write-reg $wrname($w) $v}    
      CLEAR       {write-reg $wrname($w) $v}
      
      EMPTY       {:modify MEMDISPLAY :empty T}
      REDISPLAY	  {click-redisplay}
      default     {puts stdout $arg}
   }
}

# This seems to work!!!!!!
#START      {write-reg $wrname($w) $v}
#STOP       {write-reg $wrname($w) $v}


set selectmodulemenu {1 2 3 4 5 6 7 8}
set nbr_of_segment {2(16Kchannels) 4(8Kchannels) 8(4Kchannels) 16(2Kchannels) 32(1Kchannels)}
#set selectsegmentmenu {0 1 2 3}



proc click-segment-num s {

   global debug

 if {$debug} then {puts stderr "click-segment-num"}

    set segment $s
    :modify SEGMENT-NUM :value $segment
    set-footer "Selected Segment : $segment"
    write-reg segment.select $segment
    clear-footer
    set-footer "OK! Segment $segment selected" 
 #   click-redisplay
    
}

proc click-coinc {mm} {

 global debug
 
 if {$debug} then {puts stderr "click-coinc"}
 
 set mode $mm
 
 set z [catch {

       if {$mode == 0} then { 
 	  set-footer "Enabling coincidence mode"
 	  write-reg coinc.enable 1
 	  set-footer "Coincidence mode ON!!"
       }
 
 
       if {$mode == 1} then {
 	  set-footer "Disabling coincidence mode"
	  write-reg coinc.disable 1
	  set-footer "Coincidence mode OFF!!"
       }
     
      } m ]
  
 #click-redisplay    
}


proc click-lam {ll} {

 global debug
 
 if {$debug} then {puts stderr "click-lam"}
 
 set auth $ll
 
 set z [catch {
 
       if {$auth == 0} then {
                set-footer "Enabling LAM"
	        write-reg enable.lam 1
                set-footer "LAM ENABLED!!"
#	        clear-footer
       }
      
       if {$auth == 1} then {
         	set-footer "Disabling LAM"
		write-reg disable.lam 1
		set-footer "LAM DISABLED!!"
#		clear-footer
       }
       
      } m ]
   
#   click-redisplay
}
     
      
proc click-select-segment {} {

   global selectsegmentmenu debug nbr_of_seg
   
 if {$debug} then {puts stderr "click-select-segment"}

   set segmentchoice1 [read-reg config.bit1]
   set segmentchoice2 [read-reg config.bit2]
   set segmentchoice3 [read-reg config.bit3]

   if {$segmentchoice1 == 0 && $segmentchoice2 == 0 && $segmentchoice3 == 0} then {
      set selectsegmentmenu {0 1}
      set nbr_of_seg 2
      :modify SEGMENT-NBR :strings $selectsegmentmenu
      set-footer "You are working with 2 segments of 16K channels"
   }

   if {$segmentchoice1 == 1 && $segmentchoice2 == 0 && $segmentchoice3 == 0} then {
      set selectsegmentmenu {0 1 2 3}
      set nbr_of_seg 4
      :modify SEGMENT-NBR :strings $selectsegmentmenu
      set-footer "You are working with 4 segments of 8K channels"
   }

   if {$segmentchoice1 == 0 && $segmentchoice2 == 1 && $segmentchoice3 == 0} then {
      set selectsegmentmenu {0 1 2 3 4 5 6 7}
      set nbr_of_seg 8
      :modify SEGMENT-NBR :strings $selectsegmentmenu
      set-footer "You are working with 8 segments of 4K channels"
   }

   if {$segmentchoice1 == 1 && $segmentchoice2 == 1 && $segmentchoice3 == 0} then {
       set selectsegmentmenu {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15}
       set nbr_of_seg 16
       :modify SEGMENT-NBR :strings $selectsegmentmenu
       set-footer "You are working with 16 segments of 2K channels"
   }

   if {$segmentchoice1 == 0 && $segmentchoice2 == 0 && $segmentchoice3 == 1} then {
       set selectsegmentmenu {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 \
                                      19 20 21 22 23 24 25 26 27 28 29 30 31}
       set nbr_of_seg 32
       :modify SEGMENT-NBR :strings $selectsegmentmenu
       set-footer "You are working with 32 segments of 1K channels"
   }
  
   if {($segmentchoice1 == 1 && $segmentchoice2 == 0 && $segmentchoice3 == 1)||($segmentchoice1 == 1 && $segmentchoice2 == 1 && $segmentchoice3 == 0)||
      ($segmentchoice1 == 1 && $segmentchoice2 == 1 && $segmentchoice3 == 1)} then {
      set selectsegmentmenu {}
      :modify SEGMENT-NBR :strings $selectsegmentmenu
      set-footer "This configuration is NOT DEFINED!!"
   }    

#  redisplay-module
#   click-redisplay

}


proc click-config {} {

  global debug
  
 if {$debug} then {puts stderr "click-config"}
   write-reg config %00000
   set cvsn1 [read-reg vsn1.enable]
   set cvsn2 [read-reg vsn2.enable]
   set cbit1 [read-reg config.bit1]
   set cbit2 [read-reg config.bit2]
   set cbit3 [read-reg config.bit3]
   set cnf [concat $cbit3$cbit2$cbit1$cvsn2$cvsn1]
   write-reg config %$cnf
 #  redisplay-module
 #   click-redisplay
}


proc click-stop-go {sg} {

  global debug 
  
  if {$debug} then {puts stderr "click-stop-go"}
  set state $sg
  set z [catch {
       if {$state==1} then {
          set-footer "Stopping CASCADE singles histogramming [date]"
	  :modify STOP :colour red
          :modify START :colour green
          write-reg stop.hist 1
	  inform CC write-reg SetI 1
          set-footer "CASCADE SINGLES DaQ STopped [date]"
       }
       if {$state==0} then {
          set-footer "STarting CASCADE singles histogramming [date]"
          :modify START :colour red
	  :modify STOP :colour green
	  write-reg start.hist 1
          inform CC write-reg UnSetI 1
	  set-footer "CASCADE SINGLES DaQ STarted [date]"
       }
      } m ]
#  redisplay-module
#    click-redisplay
}


proc make-frame {} {
  

   global env maxmodule selectmodulemenu 
   global camcrate camstation vsn1 vsn2
   global segmentnbr selectsegmentmenu  
   global memAddr memAddrInc

   :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10; :col-gap 10
      :vskip 10

      :number MODULE-NUM  :label "Module Number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 50
      :text CAM-CRATE   :label "CAMAC Crate:"    :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:"  :w 5 :value $camstation :deaf T

      :next-row T
      :message M1 :label "Configuration Control Register :" :bold T
      
      :next-row T; :col-gap 40
      :hskip 30
      :checkbox EVSN1  :label VSN1:
      :checkbox EVSN2  :label VSN2:
      :checkbox ESS1   :label SS1:
      :checkbox ESS2   :label SS2:
      :checkbox ESS3   :label SS3:
      :hskip 5
      :message M2 :label "Load Control Register:" :bold T
      :hskip 1
      :button CONFIG :label "LOAD" :colour yellow :command {click-select-segment; click-config}

      :next-row T
      :message M11 :label "Segment Selection :" :bold T
      

      :next-row T
      :number SEGMENT-NUM  :label "Current Segment:" :min 0 :max $segmentnbr :w 5
      :menubutton SEGMENT-NBR :label "select:" :strings "$selectsegmentmenu" 
      :hskip 20
      :button CLEAR :label "CLEAR"
      :hskip 35
      :choice LAM :label "LAM" :strings [list "Enable" "Disable" "Test"] :exclusive T :value 1 

      :row-gap 5; :next-row T
      :message M3 :label "ADC's VSN1 & VSN2" :bold T
      :hskip 30
      :text CONFIGVSN1 :label VSN1: :w 5 :value $vsn1
      :hskip 20
      :text CONFIGVSN2 :label VSN2: :w 5 :value $vsn2
      :hskip 10
      :choice COINCMODE :label "Coincidence Mode" :strings [list "Enable" "Disable"] :exclusive T :value 1 
      
      :next-row T
      :text ADDR :label "Memory address:" :w 8  :value $memAddr  :valuex 18c
      :button UPDATE  :label read  :command do_absolute_scan_mem
      :checkbox INCR :label "increment address" :value $memAddrInc
      :button EMPTY     :label "empty memory display"

      :panel CLICK :layout T :padx 10
      :layout H; :col-gap 15
      :hskip 40; :vskip 10

      :message M4 :label "Analyse Control:" :bold T
      :button CLEARMEM :label "MemClear"
      :hskip 10
      :button START :label "START" :colour green 
      :hskip 10
      :button STOP :label "STOP" :colour red 
      :hskip 10
      :button BROWSER :label "View Histogramm..." :command "inform hist click-show"
      :hskip 20
      :button REDISPLAY :label "Redisplay"
      
      :next-row T
      :galley MEMDISPLAY :rows 15 :cols 80 :font fixed 

      :show T

}


proc click_spectra {} {
   global maxadc adcchannels module modulename
   global SpectrumServer

   for {set i 0} {$i < $maxadc} {incr i} {

      set z [catch {eg "(spectrum :path '/$SpectrumServer' :range $adcchannels :name '$modulename#$module.Adc$i' !new)" } m]

#    Allow "Spectrum already exists" so that further spectra can be created
      if {$z!=0 && $m==0x30004} then {set z 0}
      if {$z!=0} then {
          display-eg-error-report self $m "Attempting to create spectrum $module.$i"
          clear-footer
          error $m
      }
   }
}





