# LC3377.tcl---LeCroy 3377 TDC module control frame
#   see  CDOC219


set frame LC3377
set frametitle "LeCroy 3377 TDC Setup & Monitor"
set icontitle "LC3377"

set mname "lc3377"

set maxmodule 32

set vsn "0x00"

set mode 0
set serial 0

set scale 0
set offset 0
set timeout 0

set adcdata "0x0000"

set wrname(CLEAR)       clear
set wrname(TESTLAM)     testlam
set wrname(CLEARLAM)    clearlam
set wrname(DISABLE)     disable
set wrname(ENABLE)      enable
set wrname(TEST)        test
set wrname(TESTBUFFERING)  testbuffering
set wrname(TESTBUSY)    testbusy

set wrname(DATA)	data

set wrname(VSN)		control0.vsn
set wrname(MODE)	control0.mode
set wrname(DSV)		control0.dsv
set wrname(EDGE)	control0.edge
set wrname(RMODE)	control0.rmode
set wrname(BMODE)	control0.bmode
set wrname(HMODE)	control0.hmode

set wrname(WIDTH)	control1.width
set wrname(DELAY)	control1.delay
set wrname(UNIT)	control1.unit
set wrname(MPI)		control1.mpi
set wrname(FMODE)	control1.fmode
set wrname(SERIAL)	control1.serial

set wrname(HITS)	control2.hits
set wrname(SCALE)	control2.scale

set wrname(REQ) 	control3.req
set wrname(OFFSET)	control3.offset

set wrname(TIMEOUT)	control4.timeout

set wrname(PULSES)	control5.pulses
set wrname(CLOCK)	control5.clock
set wrname(TENABLE)	control5.enable


set wrname(STATUS)      status

set rrname(CLEAR)       clear
set rrname(TESTLAM)     testlam
set rrname(CLEARLAM)    clearlam
set rrname(DISABLE)     disable
set rrname(ENABLE)      enable
set rrname(TEST)        test
set rrname(TESTBUFFERING)  testbuffering
set rrname(TESTBUSY)    testbusy

set rrname(VSN)		control0.vsn
set rrname(MODE)	control0.mode
set rrname(DSV)		control0.dsv
set rrname(EDGE)	control0.edge
set rrname(RMODE)	control0.rmode
set rrname(BMODE)	control0.bmode
set rrname(HMODE)	control0.bmode

set rrname(WIDTH)	control1.width
set rrname(DELAY)	control1.delay
set rrname(UNIT)	control1.unit
set rrname(MPI)		control1.mpi
set rrname(FMODE)	control1.fmode
set rrname(SERIAL)	control1.serial

set rrname(HITS)	control2.hits
set rrname(SCALE)	control2.scale

set rrname(REQ) 	control3.req
set rrname(OFFSET)	control3.offset

set rrname(TIMEOUT)	control4.timeout

set rrname(PULSES)	control5.pulses
set rrname(CLOCK)	control5.clock
set rrname(TENABLE)	control5.enable

set rrname(STHITL)	status.testhitlen
set rrname(STATUS)        status



for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac


proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug scale
   if {$debug} then {puts stderr "redisplay-module with arguments"}
   camac-address

   set register control0.vsn
   update-text-widget $register [read-reg $register]
   set register control0.dsv
   update-widget $register [read-reg $register]
   set register control0.edge
   update-widget $register [read-reg $register]
   set register control0.rmode
   update-widget $register [read-reg $register]
   set register control0.bmode
   update-widget $register [read-reg $register]
   set register control0.hmode
   update-widget $register [read-reg $register]
   set register control0.mode
   update-text-widget $register [read-reg $register]

   set register control1.delay
   update-widget $register [read-reg $register]
   set register control1.width
   update-widget $register [read-reg $register]
   set register control1.unit
   update-widget $register [read-reg $register]
   set register control1.mpi
   update-widget $register [read-reg $register]
   set register control1.fmode
   update-widget $register [read-reg $register]
   set register control1.serial
   update-text-widget $register [read-reg $register]

   set register control2.hits
   update-widget $register [read-reg $register]
   set register control2.scale
    update-widget $register [read-scale]

   set register control3.req
   update-widget $register [read-reg $register]
   set register control3.offset
    update-widget $register [read-offset]

   set register control4.timeout
    update-widget $register [read-timeout]

   set register control5.pulses
   update-widget $register [read-reg $register]
   set register control5.clock
   update-widget $register [read-reg $register]
   set register control5.enable
   update-widget $register [read-reg $register]

}

proc click-select-adc {i} {}

proc click arg {
   global debug rrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {cleanup-frame; return}
   if {$c==":quit"} then {click-quit; return}
   switch $w {
      MODULE-SEL-MENU -
      MODULE-SEL      -
      MODULE-NUM      {click-select-module $v}

      ALL-MODULES {click-all-modules $v}
 
      READADC   {click-read-data $w}

      VSN      {click-text $w $v}

      MODE      {click-text $w $v}

      DSV	-
      EDGE	-
      RMODE	-
      BMODE	-
      HMODE	-

      WIDTH	-
      DELAY	-
      UNIT	-
      MPI	-
      FMODE	-
      SERIAL	{click-text $w $v}

      HITS      -
      SCALE     {write-scale $v}

      REQ      -
      OFFSET     {write-offset $v}

      TIMEOUT     {write-timeout $v}

      PULSES     -
      CLOCK     -
      TENABLE     -

      CLEAR	    -
      TEST          -
      CLEARLAM      -
      DISABLE	    -
      ENABLE	    {write-reg $rrname($w) 0}

      TESTLAM	    -
      TESTBUFFERING -
      TESTBUSY	    {read-reg $rrname($w)}

      REDISPLAY	{click-redisplay}
      default   {puts stdout $arg}
   }
}


proc make-frame {} {
  global env camcrate camstation maxmodule vsn mode serial scale offset timeout adcdata

set selectmodulemenu {1 2 3 4 5 6 7 8 9 10 11 12}
set dsvchoice {"0.5 ns" "1.0 ns" "2.0 ns" "4.0 ns"}
set edgechoice {"Rising ONLY" "Both"}
set rmodechoice {"CAMAC readout" "ECL readout"}
set bmodechoice {"Single buffer" "Multi-event buffer"}
set hmodechoice {"Always Header" "Skip header"}

set widthchoice {0 1 2 3 4 5 6 7 8 9 10 11 12 15 14 15}
set delaychoice {0 1 2 3 4 5 6 7 8 9 10 11 12 15 14 15}
set unitchoice {"25 ns" "50 ns" "100 ns" "external"}
set mpichoice {"no MPI" "800 ns" "1600 ns" "3200 ns"}
set fmodechoice {"normal" "fast"}

set hitschoice {16 1 2 3 4 5 6 7 8 9 10 11 12 15 14 15}

set reqchoice {0us 2us 4us 6us 8us 10us 12us 14us 16us 18us 20us 22us 24us 26us 30us}

set pulseschoice {0 1 2 3 4 5 6 7 8 9 10 11 12 15 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31}
set clockchoice {"100 ns" "200 ns" "400 ns" "800 ns"}



  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10 :pady 10
     :layout H; :row-gap 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 100
      :text CAM-CRATE   :label "CAMAC Crate:"   :w 5 :value $camcrate :deaf T
      :text CAM-STATION :label "CAMAC Station:" :w 5 :value $camstation :deaf T

      :next-row T; :hskip 10
      :message M1 :label "Control Register 0:" :bold T :valuex 100
      :next-row T; :hskip 10
      :text VSN :label "VSN:" :w 5 :value '$vsn' :valuex 100
      :next-row T; :hskip 10
      :text MODE :label "Mode:" :w 5 :value '$mode' :valuex 100


    :panel P1 :layout L :padx 10
      :layout V; :row-gap 15

      :choice-stack DSV  :label "Data Shift Value:" :exclusive T  \
         :strings $dsvchoice :value 0 
      :choice-stack EDGE  :label "Edge Recording:" :exclusive T    \
         :strings $edgechoice  :value 0 
      :choice-stack RMODE  :label "Readout Mode:" :exclusive T   \
         :strings $rmodechoice  :value 0
      :choice-stack BMODE  :label "Buffer Mode:" :exclusive T   \
         :strings $bmodechoice  :value 0
      :choice-stack HMODE  :label "Header Mode:" :exclusive T   \
         :strings $hmodechoice  :value 0

    :panel P2 :layout L :padx 10
      :layout V; :row-gap 15
      :choice-stack WIDTH  :label "Trigger Output Pulse Width:" :exclusive T  \
         :strings $widthchoice :value 0
      :choice-stack DELAY  :label "Trigger Pulse Delay:" :exclusive T  \
         :strings $delaychoice :value 0
      :choice-stack UNIT  :label "Trigger clock unit:" :exclusive T  \
         :strings $unitchoice :value 0
      :choice-stack MPI  :label "Measure Pause Interval:" :exclusive T  \
         :strings $mpichoice :value 0
      :choice-stack FMODE  :label "FAST FERA Mode:" :exclusive T  \
         :strings $fmodechoice :value 0
      :text SERIAL :label "SERIAL \#:" :w 5 :value '$serial' :valuex 100

    :panel P3 :layout L :padx 10
      :layout V; :row-gap 15
      :choice-stack HITS  :label "Maximum hits:" :exclusive T   \
         :strings $hitschoice  :value 15
      :text SCALE :label "Maximum full scale:" :w 5 :value '$scale' :valuex 100

    :panel P4 :layout L :padx 10
      :layout V; :row-gap 15
      :choice-stack REQ  :label "Request delay:" :exclusive T   \
         :strings $reqchoice  :value 0
      :text OFFSET :label "Offset / Max time range:" :w 5 :value '$offset' :valuex 100

    :panel P5 :layout L :padx 10
      :layout V; :row-gap 15

      :text TIMEOUT :label "Timeout:" :w 5 :value '$timeout' :valuex 100

    :panel P6 :layout L :padx 10
      :layout V; :row-gap 15
      :choice-stack PULSES  :label "Number of pulses:" :exclusive T   \
         :strings $pulseschoice  :value 0
      :choice-stack CLOCK  :label "Test mode clock:" :exclusive T   \
         :strings $clockchoice  :value 0
	:checkbox TENABLE :label "Test Enable"

    :panel P9 :layout B :padx 10 :pady 10 :after FOOTER
      :layout H; :hskip 500
      :checkbox ALL-MODULES :label "Act on ALL modules?"

      :row-gap 15; :next-row T; :col-gap 50
      :checkbox TESTLAM :label "LAM present" :deaf T
      :checkbox TESTBUSY  :label "Busy"    :deaf T
      :checkbox TESTBUFFERING  :label "buffering in progress"  :deaf T
      :text ADCDATA :label "Data:" :w 10 :value $adcdata :deaf T
      :col-gap 0
      :button READADC :label "read"
   
   :panel CLICK :layout B :padx 10 :after FOOTER
      :layout H; :col-gap 20
      :button REDISPLAY :label "Redisplay"
      :hskip 25
      :button CLEAR     :label "Clear Module"
      :button TEST      :label "Test"
      :button ENABLE    :label "Enable LAM"
      :button DISABLE   :label "Disable LAM"
      :button CLEARLAM  :label "Clear LAM"

      :show T

}

proc read-scale {} {
    global scale
    set scale [expr [read-reg control2.scale] * 8]
    return $scale
}

proc write-scale {i} {
    write-reg control2.scale [expr {$i/8}]
}

proc read-offset {} {
    global offset
    set offset [expr [read-reg control3.offset] * 8]
    return $offset
}

proc write-offset {i} {
    write-reg control3.offset [expr {$i/8}]
}

proc read-timeout {} {
    global timeout
    set timeout [expr [read-reg control4.timeout] * 50]
    return $timeout
}

proc write-timeout {i} {
    write-reg control4.timeout [expr {$i/50}]
}

