# LC4300B.defn.tcl


proc {LeCroy 4300} {name c n} {
          define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"
          define-register $name cCAMAC test           "-c$c -n$n -a0 -f25"
          define-register $name xCAMAC status         "-c$c -n$n -a0 -f0 -prw -l0 -b0 -i0"
          define-register $name xCAMAC status.vsn     "-c$c -n$n -a0 -f0 -prw -l8 -b0"
          define-register $name xCAMAC status.mode    "-c$c -n$n -a0 -f0 -prw -l8 -b8"
          define-register $name xCAMAC status.eps     "-c$c -n$n -a0 -f0 -prw -l1 -b8 -zd"
          define-register $name xCAMAC status.ece     "-c$c -n$n -a0 -f0 -prw -l1 -b9 -zd"
          define-register $name xCAMAC status.een     "-c$c -n$n -a0 -f0 -prw -l1 -b10 -zd"
          define-register $name xCAMAC status.cps     "-c$c -n$n -a0 -f0 -prw -l1 -b11 -zd"
          define-register $name xCAMAC status.cce     "-c$c -n$n -a0 -f0 -prw -l1 -b12 -zd"
          define-register $name xCAMAC status.csr     "-c$c -n$n -a0 -f0 -prw -l1 -b13 -zd"
          define-register $name xCAMAC status.cle     "-c$c -n$n -a0 -f0 -prw -l1 -b14 -zd"
          define-register $name xCAMAC status.ofs     "-c$c -n$n -a0 -f0 -prw -l1 -b15 -zd"
          foreach i {0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15} {
            define-register $name xCAMAC adc$i.pedestal    "-c$c -n$n -a$i -f1 -prw -l8 -b0 -i1"
            define-register $name xCAMAC adc$i.data       "-c$c -n$n -a$i -f2 -pro -l0 -b0"
          }
}


proc {LeCroy 4300_DAQ-reset} {module vsn} {
#   LC4300
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-register $module.status
   write-register $module.status.vsn $vsn
   initialise-registers $module.adc?.pedestal
   initialise-registers $module.adc??.pedestal
}

proc {LeCroy 4300_DAQ-go} {module vsn} {
#   LC4300
   read-register $module.reset
   initialise-register $module.status
   write-register $module.status.vsn $vsn
   write-register $module.status.eps 1
   write-register $module.status.ece 1
   write-register $module.status.een 1
   write-register $module.status.ofs 1
}

proc {LeCroy 4300_DAQ-halt} {args} {
#   LC4300
    set module [first $args]
    read-register $module.reset
}


#    for camacsaverestore
set {LeCroy 4300_registersavepatterns} {adc*.pedestal}
