# LC4301.tcl---LeCroy 4301 Updating Discriminator control frame



set frame LC4301
set frametitle "LeCroy 4301 FERA Driver Control"
set icontitle "LC4301"

set mname "lc4301"

set maxmodule 0
set maxadc 0
set nchannels 0

set rrname(DAC)	      DAC
set rrname(CLEAR)        clear

set wrname(DAC)	      DAC
set wrname(CLEAR)        clear



for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd clear

proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   set register DAC
   update-widget $register [read-reg $register]
}

proc click arg {
   global debug rrname wrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL-MENU -
      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      DAC       {write-reg $wrname($w) $v}

      CLEAR      {read-reg $rrname($w)}

      REDISPLAY	{}
      default   {puts stdout $arg}
      }
   click-redisplay
}

set selectmodulemenu {1 2 3 4 5 6 7 8}


proc make-frame {} {
  global env maxmodule camcrate camstation nchannels
  global selectmodulemenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10
      :vskip 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 50
      :text CAM-CRATE   :label "CAMAC Crate:"    :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:"  :w 5 :value $camstation :deaf T

      :next-row T; :col-gap 50
      :text DAC :label "DAC Control Register:" :w 8    :value 0

      :next-row T; :col-gap 30
      :hskip 50
      :button REDISPLAY     :label "Redisplay"
      :hskip 100
      :button CLEAR  :label "Generate Clear"

   :show T

}

#proc EG args {puts stdout "$args"; return 7}
