# LC4413.tcl---LeCroy 4413 Updating Discriminator control frame
#   see DOC229



set frame LC4413
set frametitle "LeCroy 4413 Updating Discriminator Setup & Monitor"
set icontitle "LC4413"

set mname "lc4413"

set maxmodule 8
set maxadc 0
set nchannels 0

set rrname(MASK)	mask
set rrname(THRESHOLD)   threshold
set rrname(MANUAL)	manualmode
set rrname(TEST)        test
set rrname(LOCAL)       localmode
set rrname(REMOTE)      remotemode
set rrname(SWITCHTEST)  switchtest

set wrname(MASK)	mask
set wrname(THRESHOLD)   threshold
set wrname(MANUAL)	manualmode
set wrname(TEST)        test
set wrname(LOCAL)       localmode
set wrname(REMOTE)      remotemode
set wrname(SWITCHTEST)  switchtest



for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd test

proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   set register mask
   update-widget $register [read-reg $register]
   set register threshold
   update-widget $register [read-reg $register]
  if {[read-reg switchtest] == "%11"} then {:modify MODE :value 1} \
    else {:modify MODE :value 0}
}

proc click-mode v {
#    if v=0 set local mode f(24); if v=1 set remote mode f(26)
#    f(27) returns q=1 if in remote mode
  if {$v == 1} then {read-reg remotemode} else {read-reg localmode}
}

proc click arg {
   global debug rrname wrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL-MENU -
      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      MASK      -
      THRESHOLD {write-reg $wrname($w) $v}

      MANUAL    {write-reg $wrname($w) 1}

      TEST      {read-reg $rrname($w)}

      MODE      {click-mode $v}

      REDISPLAY	{}
      default   {puts stdout $arg}
      }
   click-redisplay
}

set selectmodulemenu {1 2 3 4 5 6 7 8}


proc make-frame {} {
  global env maxmodule camcrate camstation nchannels
  global selectmodulemenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10
      :vskip 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 50
      :text CAM-CRATE   :label "CAMAC Crate:"    :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:"  :w 5 :value $camstation :deaf T

      :next-row T; :col-gap 50
      :text MASK :label "Mask Register:" :w 8    :value 0
      :text THRESHOLD :label "Threshold:" :w 8   :value 0
      :button MANUAL :label "Set Manual Threshold"

      :next-row T; :col-gap 30
      :hskip 50
      :button REDISPLAY     :label "Redisplay"
      :hskip 100
      :button TEST  :label "Test"
      :choice MODE  :label "Mode" :strings [list Local Remote]


   :show T

}

#proc EG args {puts stdout "$args"; return 7}
