# LC4415A.tcl---LeCroy 4415A Non-Updating Discriminator control frame
#   see DOC230



set frame LC4415A
set frametitle "LeCroy 4415A Non-Updating Discriminator Setup & Monitor"
set icontitle "LC4415A"

set mname "lc4415a"

set maxmodule 8
set maxadc 0
set nchannels 0

set rrname(TEST)        test
set rrname(SWITCH)      switchtest

set wrname(MASK)	mask
set wrname(TESTMODE)    testmode
set wrname(TEST)        test
set wrname(SWITCH)      switchtest


for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd test

proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   if {[read-reg switchtest] == "%11"} then {set vl 1} else {set vl 0}
   update-widget switchtest $vl
}

proc click arg {
   global debug rrname wrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {cleanup-frame; return}
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL-MENU -
      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      MASK         -
      TESTMODE     {write-reg $wrname($w) $v}

      TEST      {read-reg $rrname($w)}

      REDISPLAY	{click-redisplay}
      default   {puts stdout $arg}
      }
}

set selectmodulemenu {1 2 3 4 5 6 7 8}


proc make-frame {} {
  global env maxmodule camcrate camstation nchannels
  global selectmodulemenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10
      :vskip 10

      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 100
      :text CAM-CRATE   :label "CAMAC Crate:"   :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:" :w 5 :value $camstation :deaf T

      :next-row T
      :text MASK :label "Mask Register:" :w 8 :value 0
      :col-gap 40
      :choice TESTMODE :label "Test Mode:" :strings "[list Disable Enable]" :value 0
      :choice SWITCH :label "Operation Mode:" :strings "[list LOCAL REMOTE]" :value 0 :deaf T

      :next-row T; :col-gap 50
      :hskip 50
      :button REDISPLAY     :label "Redisplay"
      :button TEST  :label "Test"


   :show T

}

#proc EG args {puts stdout "$args"; return 7}
