# LC4532.tcl---LeCroy 4532 Majority Logic Unit control frame
#   see DOC233



set frame LC4532
set frametitle "LeCroy 4532 Majority Logic Unit Setup & Monitor"
set icontitle "LC4532"

set mname "lc4532"

set maxmodule 8
set maxadc 0
set nchannels 0

set rrname(PATTL)	pattern.L
set rrname(PATTH)       pattern.H
set rrname(PATTC)	pattern.CLR
set rrname(LAM)         status.LAM
set rrname(LAMENABLE)   status.LAMenable
set rrname(MEMENABLE)   status.MEMenable
set rrname(CENABLE)     status.Cenable

set rrname(TESTLAM)     testlam
set rrname(CLEAR)       clear
set rrname(CLRLAM)     test+clrlam

set wrname(TESTLAM)     testlam
set wrname(CLEAR)       clear
set wrname(CLRLAM)     test+clrlam


for {set sid [array startsearch wrname]} {[array anymore wrname $sid]} { } {
	set element [array nextelement wrname $sid]
	set wname($wrname($element)) $element
}
for {set sid [array startsearch rrname]} {[array anymore rrname $sid]} { } {
	set element [array nextelement rrname $sid]
	set wname($rrname($element)) $element
}

loadsource common.camac
set reset_cmd clear

proc repaint {} {
  global module
  :modify MODULE-NUM :value $module
}

proc redisplay-module {} {
   global debug
   if {$debug} then {puts stderr "redisplay-module"}
   camac-address
   set register pattern.L
   update-widget $register [read-reg $register]
   set register pattern.H
   update-widget $register [read-reg $register]
   set register status.LAM
   update-widget $register [read-reg $register]
   set register status.LAMenable
   update-widget $register [read-reg $register]
   set register status.MEMenable
   update-widget $register [read-reg $register]
   set register status.Cenable
   update-widget $register [read-reg $register]
   set register testlam
   update-widget $register [read-reg $register]
}

proc click arg {
   global debug rrname
   if {$debug} then {puts stderr "click with argument \{$arg\}"}
   set f [lindex $arg 0]
   set c [lindex $arg 1]
   set w [lindex $arg 2]
   set v [lindex $arg 3]
   if {$f=="ER"} then {cleanup-frame; return}
   if {$c==":quit"} then {click-quit; return}
   switch -glob $w {

      MODULE-SEL-MENU -
      MODULE-SEL      -
      MODULE-NUM {click-select-module $v}

      PATTC     -
      CLRLAM    -
      CLEAR     {read-reg $rrname($w)}

      REDISPLAY	{}
      default   {puts stdout $arg}
      }
   click-redisplay
}

set selectmodulemenu {1 2 3 4 5 6 7 8}


proc make-frame {} {
  global env maxmodule camcrate camstation nchannels
  global selectmodulemenu

  :frame [self frame-name] :label "[self frame-title]" :show-footer T \
      :icon-image "@$env(ICONHOME)/camac_module" \
      :icon-name "[self icon-title]" :resize F

   :panel MODULE :layout T :padx 10
      :layout H; :row-gap 10

      :vskip 10
      :number MODULE-NUM  :label "Module number:" :min 1 :max $maxmodule :w 5 
      :menubutton MODULE-SEL :label "select:" :strings $selectmodulemenu
      :hskip 100
      :text CAM-CRATE   :label "CAMAC Crate:"    :w 5 :value $camcrate   :deaf T
      :text CAM-STATION :label "CAMAC Station:"  :w 5 :value $camstation :deaf T

      :next-row T; :col-gap 50
      :hskip 50
      :text PATTL :label "Pattern Channels 1-16:"  :w 8    :value 0 :deaf T
      :text PATTH :label "Pattern Channels 17-32:" :w 8    :value 0 :deaf T
      :hskip 30
      :button PATTC :label "Clear"

      :next-row T; :col-gap 25
      :message M  :label "Status:" :bold T
      :checkbox LAM       :label "LAM ON"            :value 0 :deaf T
      :checkbox LAMENABLE :label "LAM Enable ON"     :value 0 :deaf T
      :checkbox MEMENABLE :label "MEMORY Enable ON"  :value 0 :deaf T
      :checkbox CENABLE   :label "CLUSTER Enable ON" :value 0 :deaf T

      :next-row T; :col-gap 100
      :hskip 50
      :checkbox TESTLAM  :label "LAM present"  :deaf T
      :button CLRLAM :label "Clear LAM"

      :next-row T; :col-gap 100
      :hskip 50
      :button REDISPLAY     :label "Redisplay"
      :button CLEAR  :label "Clear"


   :show T

}
