#  MILANDELAY.defn.tcl 


proc {Milano Delay} {name c n} {
# Define write functions for registers...
# Coarse delay...
    for {set i 0; set a 15} {$i < 16} {incr i; incr a -1} {
	define-register $name xCAMAC chan$i.cdelay "-c$c -n$n -a$a -f0 -prw -i255"
    }
# Width...
    for {set i 0; set a 7} {$i < 16} {incr i; incr a -1} {
	define-register $name xCAMAC chan$i.width  "-c$c -n$n -a$a -f1 -prw -i0"
	if {!$a} {set a 16}
    }
# Coarse Range...
    for {set i 0} {$i < 2} {incr i} {
	define-register $name xCAMAC range$i "-c$c -n$n -a$i -f2 -prw -i255"
    }
# Enable...
    define-register $name xCAMAC enable "-c$c -n$n -a2 -f18 -pwo"
# Fine delay...
    for {set i 0; set a 7} {$i < 16} {incr i; incr a -1} {
	define-register $name xCAMAC chan$i.fdelay "-c$c -n$n -a$a -f3 -prw -i0"
	if {!$a} {set a 16}
    }
# LoadRAM...
    for {set i 0} {$i < 16} {incr i} {
	define-register $name cCAMAC loadRAM$i "-c$c -n$n -a$i -f25"
    }
} 



proc {Milano Delay_DAQ-reset} {module vsn} {
   write-register $module.enable 0
   if {[read-register Camac.Status] != "%11"} then {no-QX $module}
   initialise-registers $module.chan*.cdelay
   initialise-registers $module.chan*.fdelay
   initialise-registers $module.range?
   initialise-registers $module.chan*.width
   write-registers $module.loadRAM* 0
   write-register $module.enable 0xff
}

proc {Milano Delay_DAQ-go} {module vsn} {
   write-registers $module.loadRAM* 0
}

proc {Milano Delay_DAQ-halt} {module vsn} {
}

#    for camacsaverestore
set {Milano Delay_registersavepatterns} {chan*.cdelay chan*.fdelay range* chan*.width loadRAM*}
