#  ORTEC413.defn.tcl


proc {Ortec 413} {name c n} {
          define-register $name cCAMAC reset           "-c$c -n$n -a0 -f9"
          define-register $name cCAMAC clear           "-c$c -n$n -a0 -f9"
          define-register $name xCAMAC control1        "-c$c -n$n -a0 -f0 -prw -l0 -b0 -i0"
          define-register $name xCAMAC control.vsn     "-c$c -n$n -a0 -f0 -prw -l8 -b0 -zd"
          define-register $name xCAMAC control.mode    "-c$c -n$n -a0 -f0 -prw -l8 -b8 -zx"
          define-register $name xCAMAC control.zse     "-c$c -n$n -a0 -f0 -prw -l1 -b8 -zd"
          define-register $name xCAMAC control.een     "-c$c -n$n -a0 -f0 -prw -l1 -b9 -zd"
          define-register $name xCAMAC control.cme     "-c$c -n$n -a0 -f0 -prw -l1 -b12 -zd"
          define-register $name xCAMAC control.csr     "-c$c -n$n -a0 -f0 -prw -l1 -b13 -zd"
          define-register $name xCAMAC control.cle     "-c$c -n$n -a0 -f0 -prw -l1 -b14 -zd"
          define-register $name xCAMAC control.ofs     "-c$c -n$n -a0 -f0 -prw -l1 -b15 -zd"
          define-register $name xCAMAC control2        "-c$c -n$n -a1 -f0 -prw -l5 -b0 -zx -i0"
          define-register $name xCAMAC gate1.enable    "-c$c -n$n -a1 -f0 -prw -l1 -b0 -zd"
          define-register $name xCAMAC gate2.enable    "-c$c -n$n -a1 -f0 -prw -l1 -b1 -zd"
          define-register $name xCAMAC gate3.enable    "-c$c -n$n -a1 -f0 -prw -l1 -b2 -zd"
          define-register $name xCAMAC gate4.enable    "-c$c -n$n -a1 -f0 -prw -l1 -b3 -zd"
          define-register $name xCAMAC gatem.enable    "-c$c -n$n -a1 -f0 -prw -l1 -b4 -zd"
          foreach i {0 1 2 3} {
            define-register $name xCAMAC adc$i.lld     "-c$c -n$n -a$i -f1 -prw -l8 -b0 -i36"
            define-register $name xCAMAC adc$i.data    "-c$c -n$n -a$i -f2 -pro -l0 -b0"
          }
}


proc {Ortec 413_DAQ-reset} {module vsn} {
#   ORTEC413
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-register $module.control1
   initialise-register $module.control2
   write-register $module.control.vsn $vsn
   initialise-registers $module.adc?.lld
}

proc {Ortec 413_DAQ-go} {module vsn} {
#   ORTEC413
   read-register $module.reset
#   initialise-register $module.control2
   initialise-register $module.control1
   write-register $module.control.vsn $vsn
   write-register $module.control.ofs 1
}

proc {Ortec 413_DAQ-halt} {args} {
#   ORTEC413
   set module [first $args]
   read-register $module.reset
}

#    for camacsaverestore
set {Ortec 413_registersavepatterns} {adc?.lld control2}
