#  QDC1612F.defn.tcl


proc {QDC1612F} {name c n} {
          define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"
          define-register $name xCAMAC status         "-c$c -n$n -a0 -f0 -prw -l0 -b0 -i0"
          define-register $name xCAMAC status.mode    "-c$c -n$n -a0 -f0 -prw -l9 -b0 -i0"
          define-register $name xCAMAC status.Mgate   "-c$c -n$n -a0 -f0 -prw -l4 -b9 -i0"
          define-register $name xCAMAC status.eps     "-c$c -n$n -a0 -f0 -prw -l1 -b0 -zd"
          define-register $name xCAMAC status.ece     "-c$c -n$n -a0 -f0 -prw -l1 -b1 -zd"
          define-register $name xCAMAC status.een     "-c$c -n$n -a0 -f0 -prw -l1 -b2 -zd"
          define-register $name xCAMAC status.cps     "-c$c -n$n -a0 -f0 -prw -l1 -b3 -zd"
          define-register $name xCAMAC status.cce     "-c$c -n$n -a0 -f0 -prw -l1 -b4 -zd"
          define-register $name xCAMAC status.csr     "-c$c -n$n -a0 -f0 -prw -l1 -b5 -zd"
          define-register $name xCAMAC status.cle     "-c$c -n$n -a0 -f0 -prw -l1 -b6 -zd"
          define-register $name xCAMAC status.ofs     "-c$c -n$n -a0 -f0 -prw -l1 -b7 -zd"
          define-register $name xCAMAC status.indiv   "-c$c -n$n -a0 -f0 -prw -l1 -b8 -zd"
          define-register $name xCAMAC vsn1           "-c$c -n$n -a1 -f0 -prw -l8 -b0 -zd"
          define-register $name xCAMAC vsn2           "-c$c -n$n -a2 -f0 -prw -l8 -b0 -zd"
          define-register $name xCAMAC Vdac           "-c$c -n$n -a3 -f16 -pwo -l8 -b0"
          for {set i 0} {$i < 16} {incr i} {
            define-register $name xCAMAC channel$i.pedestal    "-c$c -n$n -a$i -f1 -prw -l8 -b0 -i0"
            define-register $name xCAMAC channel$i.data        "-c$c -n$n -a$i -f2 -pro -l0 -b0"
          }
}


proc {QDC1612F_DAQ-reset} {module vsn} {
#   QDC1612F
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-register $module.status.mode
   initialise-register $module.status.Mgate
   write-register $module.vsn1 $vsn
   write-register $module.vsn2 [expr $vsn+1]
   initialise-registers $module.channel?.pedestal
   initialise-registers $module.channel??.pedestal
}

proc {QDC1612F_DAQ-go} {module vsn} {
#   QDC1612F
   read-register $module.reset
   initialise-register $module.status.mode
   write-register $module.vsn1 $vsn
   write-register $module.vsn2 [expr $vsn+1]
   write-register $module.status.eps 1
   write-register $module.status.ece 1
   write-register $module.status.een 1
}

proc {QDC1612F_DAQ-halt} {args} {
#   QDC1612F
   set module [first $args]
    read-register $module.reset
}

