# S4418T.defn.tcl   Silena 4418/T ADC

proc {Silena 4418/T} {name c n} {
          define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"
          define-register $name cCAMAC test           "-c$c -n$n -a0 -f25"
          define-register $name xCAMAC status         "-c$c -n$n -a14 -f4 -prw -l0 -b0 -i0"
          define-register $name xCAMAC status.vsn     "-c$c -n$n -a14 -f4 -prw -l8 -b0"
          define-register $name xCAMAC status.mode    "-c$c -n$n -a14 -f4 -prw -l8 -b8"
          define-register $name xCAMAC status.sub     "-c$c -n$n -a14 -f4 -prw -l1 -b9 -zd"
          define-register $name xCAMAC status.een     "-c$c -n$n -a14 -f4 -prw -l1 -b10 -zd"
          define-register $name xCAMAC status.ovf     "-c$c -n$n -a14 -f4 -prw -l1 -b11 -zd"
          define-register $name xCAMAC status.cce     "-c$c -n$n -a14 -f4 -prw -l1 -b12 -zd"
          define-register $name xCAMAC status.csr     "-c$c -n$n -a14 -f4 -prw -l1 -b13 -zd"
          define-register $name xCAMAC status.cle     "-c$c -n$n -a14 -f4 -prw -l1 -b14 -zd"
#          define-register $name xCAMAC threshold      "-c$c -n$n -a9 -f4 -prw -l8 -b0 -i28"    4418/V only
          define-register $name xCAMAC hdr.data       "-c$c -n$n -a14 -f0 -pro -l0 -b0"
          define-register $name xCAMAC hdr.data+clr   "-c$c -n$n -a14 -f2 -pro -l0 -b0"
          define-register $name xCAMAC patt.data      "-c$c -n$n -a15 -f0 -pro -l0 -b0"
          define-register $name xCAMAC patt.data+clr  "-c$c -n$n -a15 -f2 -pro -l0 -b0"
          foreach i {0 1 2 3 4 5 6 7} {
            define-register $name xCAMAC adc$i.uld    "-c$c -n$n -a$i -f1 -prw -l8 -b0 -i255"
            define-register $name xCAMAC adc$i.lld    "-c$c -n$n -a[expr $i+8] -f1 -prw -l8 -b0 -i1"
            define-register $name xCAMAC adc$i.offset "-c$c -n$n -a$i -f4 -prw -l8 -b0 -i128"
            define-register $name xCAMAC adc$i.data       "-c$c -n$n -a$i -f0 -pro -l0 -b0"
            define-register $name xCAMAC adc$i.data+clr   "-c$c -n$n -a$i -f2 -pro -l0 -b0"
          }
}

proc {Silena 4418/T_DAQ-reset} {module vsn} {
#  S4418/T
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-register $module.status
   write-register $module.status.vsn $vsn
   initialise-registers $module.adc?.uld
   initialise-registers $module.adc?.lld
   initialise-registers $module.adc?.offset
#   initialise-register $module.threshold    4418/T only
}

proc {Silena 4418/T_DAQ-go} {module vsn} {
#   S4418/T
    read-register $module.reset
    initialise-register $module.status
    write-register $module.status.vsn $vsn
    write-register $module.status.een 1
    write-register $module.status.cce 1
    write-register $module.status.csr 1
}

proc {Silena 4418/T_DAQ-halt} {args} {
#   S4418/T
    set module [first $args]
    read-register $module.reset
}

#    for camacsaverestore
set {Silena 4418/T_registersavepatterns} {adc?.uld adc?.lld adc?.offset}
