#  fdt32.defn.tcl 

proc {FDT32} {name c n} {
          define-register $name cCAMAC reset          "-c$c -n$n -a0 -f9"
          define-register $name cCAMAC clearaddr      "-c$c -n$n -a0 -f10"
          define-register $name cCAMAC clearfifo      "-c$c -n$n -a2 -f9"
          define-register $name cCAMAC enablelam      "-c$c -n$n -a0 -f26"
          define-register $name cCAMAC disablelam     "-c$c -n$n -a0 -f24"
          define-register $name cCAMAC testlam        "-c$c -n$n -a0 -f8"
          define-register $name xCAMAC control        "-c$c -n$n -a0 -f16 -pwo -l0 -b0 -i0"
          define-register $name xCAMAC control.go_adc "-c$c -n$n -a0 -f16 -pwo -l1 -b3 -i0"
          define-register $name xCAMAC control.test   "-c$c -n$n -a0 -f16 -pwo -l1 -b1 -i0"
          define-register $name xCAMAC control.en_roco "-c$c -n$n -a0 -f16 -pwo -l1 -b0 -i0"
          define-register $name xCAMAC status         "-c$c -n$n -a0 -f0 -pro -l0 -b0 -zx"
          define-register $name xCAMAC status.en_roco "-c$c -n$n -a0 -f0 -pro -l1 -b8 -zd"
          define-register $name xCAMAC status.dtpause "-c$c -n$n -a0 -f0 -pro -l1 -b7 -zd"
          define-register $name xCAMAC status.dtstop  "-c$c -n$n -a0 -f0 -pro -l1 -b6 -zd"
          define-register $name xCAMAC status.pass_fera  "-c$c -n$n -a0 -f0 -pro -l1 -b5 -zd"
          define-register $name xCAMAC status.dtren   "-c$c -n$n -a0 -f0 -pro -l1 -b4 -zd"
          define-register $name xCAMAC status.notfull "-c$c -n$n -a0 -f0 -pro -l1 -b3 -zd"
          define-register $name xCAMAC status.notempty  "-c$c -n$n -a0 -f0 -pro -l1 -b2 -zd"
          define-register $name xCAMAC status.nothfull  "-c$c -n$n -a0 -f0 -pro -l1 -b1 -zd"
          define-register $name xCAMAC status.dtpass  "-c$c -n$n -a0 -f0 -pro -l1 -b0 -zd"
          define-register $name xCAMAC gate.delay     "-c$c -n$n -a6 -f16 -pwo -l0 -b0"
          define-register $name xCAMAC gate.length    "-c$c -n$n -a7 -f16 -pwo -l0 -b0"
          define-register $name xCAMAC val.delay      "-c$c -n$n -a8 -f16 -pwo -l0 -b0"
          define-register $name xCAMAC ren.delay      "-c$c -n$n -a9 -f16 -pwo -l0 -b0"
          define-register $name xCAMAC test.#1        "-c$c -n$n -a0 -f17 -pwo -l0 -b0"
          define-register $name xCAMAC test.#2        "-c$c -n$n -a1 -f17 -pwo -l3 -b0"
          define-register $name xCAMAC test.#3        "-c$c -n$n -a1 -f17 -pwo -l3 -b3"
          define-register $name xCAMAC lutitem        "-c$c -n$n -a1 -f0 -prw -l0 -b0 -zx"
          define-register $name xCAMAC readfifoitem   "-c$c -n$n -a2 -f0 -w24 -pro -l0 -b0 -zx"
          define-register $name qCAMAC writelut       "-c$c -n$n -a1 -f16 -pwo -l8160 -zx"
          define-register $name qCAMAC readlut        "-c$c -n$n -a1 -f0 -pro -l8192 -zx"
          define-register $name qCAMAC readfifo       "-c$c -n$n -a2 -f0 -pro -l4096 -zx"
}


proc {FDT32_DAQ-reset} {args} {
#   FDT32
   set module [first $args]
   if {[read-register $module.reset] != "%11"} then {no-QX $module.reset}
   initialise-registers $module.*
}

proc {FDT32_DAQ-go} {args} {
   read-register  $module.reset
   write-register $module.control 9
   write-register $module.test.#1 32
}

proc {FDT32_DAQ-halt} {args} {
   read-register $module.reset
}

